#pragma clang diagnostic ignored "-Wmissing-prototypes"
#pragma clang diagnostic ignored "-Wmissing-braces"

#include <metal_stdlib>
#include <simd/simd.h>

using namespace metal;

template<typename T, size_t Num>
struct spvUnsafeArray
{
    T elements[Num ? Num : 1];
    
    thread T& operator [] (size_t pos) thread
    {
        return elements[pos];
    }
    constexpr const thread T& operator [] (size_t pos) const thread
    {
        return elements[pos];
    }
    
    device T& operator [] (size_t pos) device
    {
        return elements[pos];
    }
    constexpr const device T& operator [] (size_t pos) const device
    {
        return elements[pos];
    }
    
    constexpr const constant T& operator [] (size_t pos) const constant
    {
        return elements[pos];
    }
    
    threadgroup T& operator [] (size_t pos) threadgroup
    {
        return elements[pos];
    }
    constexpr const threadgroup T& operator [] (size_t pos) const threadgroup
    {
        return elements[pos];
    }
};

struct buffer_t
{
    int _LeftEyes;
    int _RightEyes;
    float _OpacityEnable;
    float4 _Color;
    float _Intensity;
    float _ReflectionEnable;
    float _ReflectionIntensity;
};

constant spvUnsafeArray<float2, 10> _107 = spvUnsafeArray<float2, 10>({ float2(1.440000057220458984375, 1.2999999523162841796875), float2(1.440000057220458984375, 3.8599998950958251953125), float2(1.46000003814697265625, 6.570000171661376953125), float2(1.57700002193450927734375, 9.3500003814697265625), float2(1.53400003910064697265625, 11.8500003814697265625), float2(5.21000003814697265625, 1.35000002384185791015625), float2(5.27600002288818359375, 3.8599998950958251953125), float2(5.235000133514404296875, 6.5799999237060546875), float2(5.11999988555908203125, 9.3500003814697265625), float2(5.2189998626708984375, 11.89000034332275390625) });

struct main0_out
{
    float4 o_FragColor [[color(0)]];
};

struct main0_in
{
    float2 uv0 [[user(locn0)]];
};

fragment main0_out main0(main0_in in [[stage_in]], constant buffer_t& buffer, texture2d<float> _MainTex [[texture(0)]], texture2d<float> _MaskTex [[texture(1)]], texture2d<float> _EyeTex [[texture(2)]], texture2d<float> _OpacityTex [[texture(3)]], texture2d<float> _ReflectionTex [[texture(4)]], sampler _MainTexSmplr [[sampler(0)]], sampler _MaskTexSmplr [[sampler(1)]], sampler _EyeTexSmplr [[sampler(2)]], sampler _OpacityTexSmplr [[sampler(3)]], sampler _ReflectionTexSmplr [[sampler(4)]])
{
    main0_out out = {};
    float4 _43 = _MainTex.sample(_MainTexSmplr, in.uv0);
    float4 _48 = _MaskTex.sample(_MaskTexSmplr, in.uv0);
    float _51 = _48.x;
    float4 _332;
    _332 = float4(0.0);
    for (int _328 = buffer._LeftEyes; _328 < buffer._RightEyes; )
    {
        float2 _113 = fma(in.uv0, float2(7.650000095367431640625, 13.59999370574951171875), -_107[_328]);
        _332 += (_EyeTex.sample(_EyeTexSmplr, _113) * step(distance(in.uv0, _113), 1.0));
        _328++;
        continue;
    }
    float4 _333;
    if (buffer._OpacityEnable > 0.5)
    {
        float _330;
        _330 = 0.0;
        for (int _329 = buffer._LeftEyes; _329 < buffer._RightEyes; )
        {
            float2 _154 = fma(in.uv0, float2(7.650000095367431640625, 13.59999370574951171875), -_107[_329]);
            _330 = fma(_OpacityTex.sample(_OpacityTexSmplr, _154).x, step(distance(in.uv0, _154), 1.0), _330);
            _329++;
            continue;
        }
        _333 = _332 * (buffer._Color * _330);
    }
    else
    {
        _333 = _332;
    }
    float _183 = _333.w * (_51 * buffer._Intensity);
    float _189 = _43.w;
    float3 _229 = mix(fast::clamp(_43.xyz / float3(fma(step(0.0, -_189), 9.9999999747524270787835121154785e-07, _189)), float3(0.0), float3(1.0)), fast::clamp(_333.xyz / float3(fma(step(0.0, -_183), 9.9999999747524270787835121154785e-07, _183)), float3(0.0), float3(1.0)), float3(_183));
    float3 _337;
    if (buffer._ReflectionEnable > 0.5)
    {
        float4 _335;
        _335 = float4(0.0);
        for (int _334 = buffer._LeftEyes; _334 < buffer._RightEyes; )
        {
            float2 _253 = fma(in.uv0, float2(7.650000095367431640625, 13.59999370574951171875), -_107[_334]);
            _335 += (_ReflectionTex.sample(_ReflectionTexSmplr, _253) * step(distance(in.uv0, _253), 1.0));
            _334++;
            continue;
        }
        float4 _272 = _335 * (_51 * buffer._ReflectionIntensity);
        float _277 = _272.w;
        _337 = mix(_229, fast::clamp(_272.xyz / float3(fma(step(0.0, -_277), 9.9999999747524270787835121154785e-07, _277)), float3(0.0), float3(1.0)), float3(_277));
    }
    else
    {
        _337 = _229;
    }
    out.o_FragColor = float4(_337, 1.0);
    return out;
}

