#pragma clang diagnostic ignored "-Wmissing-prototypes"
#pragma clang diagnostic ignored "-Wmissing-braces"

#include <metal_stdlib>
#include <simd/simd.h>

using namespace metal;

template<typename T, size_t Num>
struct spvUnsafeArray
{
    T elements[Num ? Num : 1];
    
    thread T& operator [] (size_t pos) thread
    {
        return elements[pos];
    }
    constexpr const thread T& operator [] (size_t pos) const thread
    {
        return elements[pos];
    }
    
    device T& operator [] (size_t pos) device
    {
        return elements[pos];
    }
    constexpr const device T& operator [] (size_t pos) const device
    {
        return elements[pos];
    }
    
    constexpr const constant T& operator [] (size_t pos) const constant
    {
        return elements[pos];
    }
    
    threadgroup T& operator [] (size_t pos) threadgroup
    {
        return elements[pos];
    }
    constexpr const threadgroup T& operator [] (size_t pos) const threadgroup
    {
        return elements[pos];
    }
};

struct buffer_t
{
    spvUnsafeArray<float, 3> u_DirLightsEnabled;
    spvUnsafeArray<float4, 3> u_DirLightsDirection;
    spvUnsafeArray<float4, 3> u_DirLightsColor;
    spvUnsafeArray<float, 3> u_DirLightsIntensity;
    spvUnsafeArray<float, 2> u_PointLightsEnabled;
    spvUnsafeArray<float4, 2> u_PointLightsPosition;
    spvUnsafeArray<float4, 2> u_PointLightsColor;
    spvUnsafeArray<float, 2> u_PointLightsIntensity;
    spvUnsafeArray<float, 2> u_PointLightsAttenRangeInv;
    spvUnsafeArray<float, 2> u_SpotLightsEnabled;
    spvUnsafeArray<float4, 2> u_SpotLightsPosition;
    spvUnsafeArray<float4, 2> u_SpotLightsColor;
    spvUnsafeArray<float, 2> u_SpotLightsIntensity;
    spvUnsafeArray<float, 2> u_SpotLightsAttenRangeInv;
    spvUnsafeArray<float4, 2> u_SpotLightsDirection;
    spvUnsafeArray<float, 2> u_SpotLightsOuterAngleCos;
    spvUnsafeArray<float, 2> u_SpotLightsInnerAngleCos;
    spvUnsafeArray<float, 2> u_AreaLightsEnabled;
    spvUnsafeArray<float4, 2> u_AreaLightsColor;
    spvUnsafeArray<float, 2> u_AreaLightsIntensity;
    spvUnsafeArray<float4, 2> u_AreaLightsPoint0;
    spvUnsafeArray<float4, 2> u_AreaLightsPoint1;
    spvUnsafeArray<float4, 2> u_AreaLightsPoint2;
    spvUnsafeArray<float4, 2> u_AreaLightsPoint3;
    spvUnsafeArray<float, 2> u_AreaLightsShape;
    spvUnsafeArray<float, 2> u_AreaLightsTwoSide;
    float4 u_FresnelCol;
    float u_FresnelIntensity;
    float u_FresnelPow;
    float u_Env;
    float u_EnvRot;
    float4 u_WorldSpaceCameraPos;
    float4 _AlbedoColor;
    float u_Metallic;
    float u_Roughness;
};

constant float3 _12987 = {};
constant float _13068 = {};
constant float4 _16073 = {};

struct main0_out
{
    float4 o_fragColor [[color(0)]];
};

struct main0_in
{
    float3 v_posWS [[user(locn1)]];
    float3 v_nDirWS [[user(locn2)]];
    float2 v_uv0 [[user(locn3)]];
};

fragment main0_out main0(main0_in in [[stage_in]], constant buffer_t& buffer, texture2d<float> u_ltc_mat [[texture(0)]], texture2d<float> u_ltc_mag [[texture(1)]], texture2d<float> u_FresnelTex [[texture(2)]], texture2d<float> u_EnvTex [[texture(3)]], sampler u_ltc_matSmplr [[sampler(0)]], sampler u_ltc_magSmplr [[sampler(1)]], sampler u_FresnelTexSmplr [[sampler(2)]], sampler u_EnvTexSmplr [[sampler(3)]])
{
    main0_out out = {};
    float3 _3727 = fast::normalize(in.v_nDirWS);
    float3 _3732 = fast::normalize(buffer.u_WorldSpaceCameraPos.xyz - in.v_posWS);
    float3 _12985;
    if (dot(_3732, _3727) < (-0.0500000007450580596923828125))
    {
        _12985 = -_3727;
    }
    else
    {
        _12985 = _3727;
    }
    float3 _3825 = pow(fast::max(buffer._AlbedoColor.xyz, float3(9.9999997473787516355514526367188e-06)), float3(2.2000000476837158203125));
    float _3829 = fast::clamp(buffer.u_Metallic, 0.0, 1.0);
    float _3765 = fast::clamp(buffer.u_Roughness, 0.0, 1.0);
    float _3834 = _3765 * _3765;
    float _3839 = _3834 * _3834;
    float3 _3779 = _3825 * (1.0 - _3829);
    float _3790 = fast::max(0.0, dot(_12985, _3732));
    float3 _3808 = mix(float3(0.0400000028312206268310546875), _3825, float3(_3829));
    float3 _4132 = fast::normalize(_12985);
    float _4135 = -_4132.z;
    float _4137 = _4132.x;
    float _4176 = fast::clamp(_4135 / length(float2(_4137, _4135)), -1.0, 1.0);
    float _4185 = abs(_4176);
    float _4188 = fma(-0.15658299624919891357421875, _4185, 1.57079601287841796875);
    float _4191 = sqrt(1.0 - _4185);
    float _12988;
    if (_4176 >= 0.0)
    {
        _12988 = _4188 * _4191;
    }
    else
    {
        _12988 = fma(-_4188, _4191, 3.1415927410125732421875);
    }
    float _4144 = acos(_4132.y);
    float _4150 = fma(fma((_4137 < 0.0) ? (-1.0) : 1.0, _12988, -1.57079637050628662109375), 0.15915493667125701904296875, buffer.u_EnvRot);
    float _4159 = fract((_4150 + floor(_4150)) + 1.0);
    float _4212 = floor(7.0);
    float2 _12992;
    float2 _12999;
    if (abs(_4212) < 0.001000000047497451305389404296875)
    {
        _12999 = float2(fma(_4159, 0.99609375, 0.001953125) * 0.5, fma(fma(_4144, 0.315823078155517578125, 0.00390625), 0.25, 0.5));
        _12992 = float2(fma(_4159, 0.998046875, 0.0009765625), fma(_4144, 0.3170664608478546142578125, 0.001953125) * 0.5);
    }
    else
    {
        float2 _12993;
        float2 _13000;
        if (abs(_4212 - 1.0) < 0.001000000047497451305389404296875)
        {
            float _4265 = fma(_4159, 0.99609375, 0.001953125);
            float _4275 = fma(fma(_4144, 0.315823078155517578125, 0.00390625), 0.25, 0.5);
            _13000 = float2(fma(_4265, 0.5, 0.5), _4275);
            _12993 = float2(_4265 * 0.5, _4275);
        }
        else
        {
            float2 _12994;
            float2 _13001;
            if (abs(_4212 - 2.0) < 0.001000000047497451305389404296875)
            {
                float _4303 = fma(_4159, 0.99609375, 0.001953125);
                float _4311 = fma(_4144, 0.315823078155517578125, 0.00390625);
                _13001 = float2(_4303 * 0.5, fma(_4311, 0.25, 0.75));
                _12994 = float2(fma(_4303, 0.5, 0.5), fma(_4311, 0.25, 0.5));
            }
            else
            {
                float2 _12995;
                float2 _13002;
                if (abs(_4212 - 3.0) < 0.001000000047497451305389404296875)
                {
                    _13002 = float2(fma(fma(_4159, 0.9921875, 0.00390625), 0.25, 0.5), fma(fma(_4144, 0.3133362829685211181640625, 0.0078125), 0.125, 0.75));
                    _12995 = float2(fma(_4159, 0.99609375, 0.001953125) * 0.5, fma(fma(_4144, 0.315823078155517578125, 0.00390625), 0.25, 0.75));
                }
                else
                {
                    float2 _12996;
                    float2 _13003;
                    if (abs(_4212 - 4.0) < 0.001000000047497451305389404296875)
                    {
                        float _4379 = fma(_4159, 0.9921875, 0.00390625);
                        float _4389 = fma(fma(_4144, 0.3133362829685211181640625, 0.0078125), 0.125, 0.75);
                        _13003 = float2(fma(_4379, 0.25, 0.75), _4389);
                        _12996 = float2(fma(_4379, 0.25, 0.5), _4389);
                    }
                    else
                    {
                        float2 _12997;
                        float2 _13004;
                        if (abs(_4212 - 5.0) < 0.001000000047497451305389404296875)
                        {
                            float _4417 = fma(_4159, 0.9921875, 0.00390625);
                            float _4425 = fma(_4144, 0.3133362829685211181640625, 0.0078125);
                            _13004 = float2(fma(_4417, 0.25, 0.5), fma(_4425, 0.125, 0.875));
                            _12997 = float2(fma(_4417, 0.25, 0.75), fma(_4425, 0.125, 0.75));
                        }
                        else
                        {
                            float2 _12998;
                            float2 _13005;
                            if (abs(_4212 - 6.0) < 0.001000000047497451305389404296875)
                            {
                                float _4455 = fma(_4159, 0.9921875, 0.00390625);
                                float _4465 = fma(fma(_4144, 0.3133362829685211181640625, 0.0078125), 0.125, 0.875);
                                _13005 = float2(fma(_4455, 0.25, 0.75), _4465);
                                _12998 = float2(fma(_4455, 0.25, 0.5), _4465);
                            }
                            else
                            {
                                float2 _15969 = float2(fma(fma(_4159, 0.9921875, 0.00390625), 0.25, 0.75), fma(fma(_4144, 0.3133362829685211181640625, 0.0078125), 0.125, 0.875));
                                _13005 = _15969;
                                _12998 = _15969;
                            }
                            _13004 = _13005;
                            _12997 = _12998;
                        }
                        _13003 = _13004;
                        _12996 = _12997;
                    }
                    _13002 = _13003;
                    _12995 = _12996;
                }
                _13001 = _13002;
                _12994 = _12995;
            }
            _13000 = _13001;
            _12993 = _12994;
        }
        _12999 = _13000;
        _12992 = _12993;
    }
    float4 _4525 = u_EnvTex.sample(u_EnvTexSmplr, _12992);
    float4 _4528 = u_EnvTex.sample(u_EnvTexSmplr, _12999);
    float4 _4531 = mix(_4525, _4528, float4(7.0 - _4212));
    float3 _4075 = ((_3779 * ((_4531.xyz / float3(_4531.w)) * buffer.u_Env)) * fast::max(float3(1.0), ((((((_3779 * 2.040400028228759765625) - float3(0.3323999941349029541015625)) * 1.0) + ((_3779 * (-4.79510021209716796875)) + float3(0.6417000293731689453125))) * 1.0) + ((_3779 * 2.755199909210205078125) + float3(0.69029998779296875))) * 1.0)) * 1.0;
    float3 _4634 = fast::normalize(mix(fast::normalize(reflect(-_3732, _12985)), _12985, float3(_3765 * _3834)));
    float _4637 = -_4634.z;
    float _4639 = _4634.x;
    float _4678 = fast::clamp(_4637 / length(float2(_4639, _4637)), -1.0, 1.0);
    float _4687 = abs(_4678);
    float _4690 = fma(-0.15658299624919891357421875, _4687, 1.57079601287841796875);
    float _4693 = sqrt(1.0 - _4687);
    float _13014;
    if (_4678 >= 0.0)
    {
        _13014 = _4690 * _4693;
    }
    else
    {
        _13014 = fma(-_4690, _4693, 3.1415927410125732421875);
    }
    float _4646 = acos(_4634.y);
    float _4652 = fma(fma((_4639 < 0.0) ? (-1.0) : 1.0, _13014, -1.57079637050628662109375), 0.15915493667125701904296875, buffer.u_EnvRot);
    float _4661 = fract((_4652 + floor(_4652)) + 1.0);
    float _4714 = floor(_3765 * 7.0);
    float2 _13025;
    float2 _13032;
    if (abs(_4714) < 0.001000000047497451305389404296875)
    {
        _13032 = float2(fma(_4661, 0.99609375, 0.001953125) * 0.5, fma(fma(_4646, 0.315823078155517578125, 0.00390625), 0.25, 0.5));
        _13025 = float2(fma(_4661, 0.998046875, 0.0009765625), fma(_4646, 0.3170664608478546142578125, 0.001953125) * 0.5);
    }
    else
    {
        float2 _13026;
        float2 _13033;
        if (abs(_4714 - 1.0) < 0.001000000047497451305389404296875)
        {
            float _4767 = fma(_4661, 0.99609375, 0.001953125);
            float _4777 = fma(fma(_4646, 0.315823078155517578125, 0.00390625), 0.25, 0.5);
            _13033 = float2(fma(_4767, 0.5, 0.5), _4777);
            _13026 = float2(_4767 * 0.5, _4777);
        }
        else
        {
            float2 _13027;
            float2 _13034;
            if (abs(_4714 - 2.0) < 0.001000000047497451305389404296875)
            {
                float _4805 = fma(_4661, 0.99609375, 0.001953125);
                float _4813 = fma(_4646, 0.315823078155517578125, 0.00390625);
                _13034 = float2(_4805 * 0.5, fma(_4813, 0.25, 0.75));
                _13027 = float2(fma(_4805, 0.5, 0.5), fma(_4813, 0.25, 0.5));
            }
            else
            {
                float2 _13028;
                float2 _13035;
                if (abs(_4714 - 3.0) < 0.001000000047497451305389404296875)
                {
                    _13035 = float2(fma(fma(_4661, 0.9921875, 0.00390625), 0.25, 0.5), fma(fma(_4646, 0.3133362829685211181640625, 0.0078125), 0.125, 0.75));
                    _13028 = float2(fma(_4661, 0.99609375, 0.001953125) * 0.5, fma(fma(_4646, 0.315823078155517578125, 0.00390625), 0.25, 0.75));
                }
                else
                {
                    float2 _13029;
                    float2 _13036;
                    if (abs(_4714 - 4.0) < 0.001000000047497451305389404296875)
                    {
                        float _4881 = fma(_4661, 0.9921875, 0.00390625);
                        float _4891 = fma(fma(_4646, 0.3133362829685211181640625, 0.0078125), 0.125, 0.75);
                        _13036 = float2(fma(_4881, 0.25, 0.75), _4891);
                        _13029 = float2(fma(_4881, 0.25, 0.5), _4891);
                    }
                    else
                    {
                        float2 _13030;
                        float2 _13037;
                        if (abs(_4714 - 5.0) < 0.001000000047497451305389404296875)
                        {
                            float _4919 = fma(_4661, 0.9921875, 0.00390625);
                            float _4927 = fma(_4646, 0.3133362829685211181640625, 0.0078125);
                            _13037 = float2(fma(_4919, 0.25, 0.5), fma(_4927, 0.125, 0.875));
                            _13030 = float2(fma(_4919, 0.25, 0.75), fma(_4927, 0.125, 0.75));
                        }
                        else
                        {
                            float2 _13031;
                            float2 _13038;
                            if (abs(_4714 - 6.0) < 0.001000000047497451305389404296875)
                            {
                                float _4957 = fma(_4661, 0.9921875, 0.00390625);
                                float _4967 = fma(fma(_4646, 0.3133362829685211181640625, 0.0078125), 0.125, 0.875);
                                _13038 = float2(fma(_4957, 0.25, 0.75), _4967);
                                _13031 = float2(fma(_4957, 0.25, 0.5), _4967);
                            }
                            else
                            {
                                float2 _15994 = float2(fma(fma(_4661, 0.9921875, 0.00390625), 0.25, 0.75), fma(fma(_4646, 0.3133362829685211181640625, 0.0078125), 0.125, 0.875));
                                _13038 = _15994;
                                _13031 = _15994;
                            }
                            _13037 = _13038;
                            _13030 = _13031;
                        }
                        _13036 = _13037;
                        _13029 = _13030;
                    }
                    _13035 = _13036;
                    _13028 = _13029;
                }
                _13034 = _13035;
                _13027 = _13028;
            }
            _13033 = _13034;
            _13026 = _13027;
        }
        _13032 = _13033;
        _13025 = _13026;
    }
    float4 _5033 = mix(u_EnvTex.sample(u_EnvTexSmplr, _13025), u_EnvTex.sample(u_EnvTexSmplr, _13032), float4(fma(_3765, 7.0, -_4714)));
    float4 _5060 = (float4(-1.0, -0.0274999998509883880615234375, -0.572000026702880859375, 0.02199999988079071044921875) * _3765) + float4(1.0, 0.0425000004470348358154296875, 1.03999996185302734375, -0.039999999105930328369140625);
    float _5062 = _5060.x;
    float2 _5080 = (float2(-1.03999996185302734375, 1.03999996185302734375) * fma(fast::min(_5062 * _5062, exp2((-9.27999973297119140625) * _3790)), _5062, _5060.y)) + _5060.zw;
    float3 _4082 = ((((_3808 * _5080.x) + float3(_5080.y * fast::clamp(50.0 * _3808.y, 0.0, 1.0))) * fast::max(float3(1.0), ((((((_3808 * 2.040400028228759765625) - float3(0.3323999941349029541015625)) * 1.0) + ((_3808 * (-4.79510021209716796875)) + float3(0.6417000293731689453125))) * 1.0) + ((_3808 * 2.755199909210205078125) + float3(0.69029998779296875))) * 1.0)) * ((_5033.xyz / float3(_5033.w)) * buffer.u_Env)) * 1.0;
    float3 _5144 = fast::normalize(-buffer.u_DirLightsDirection[0].xyz);
    float _5158 = (buffer.u_DirLightsIntensity[0] * buffer.u_DirLightsEnabled[0]) * 3.1415920257568359375;
    float3 _5172 = fast::normalize(_5144 + _3732);
    float _5186 = fast::max(0.0, dot(_12985, _5144));
    float _5193 = fast::max(0.0, dot(_12985, _5172));
    float3 _13251;
    float3 _13252;
    if (buffer.u_DirLightsEnabled[0] > 0.5)
    {
        float _5337 = 1.0 - fast::max(0.0, fast::max(0.0, dot(_3732, _5172)));
        float _5351 = _5337 * _5337;
        float _5364 = 1.0 - _5186;
        float _5392 = fma(fma(_5193, _3839, -_5193), _5193, 1.0);
        _13252 = _4082 + ((((((_3808 + ((float3(1.0) - _3808) * ((_5351 * _5351) * _5337))) * (((_3839 * 0.31830990314483642578125) / fma(_5392, _5392, 1.0000000116860974230803549289703e-07)) * (0.5 / (fma(_3834, fma(_3790, _5364, _5186), _3790 * fma(_3834, _5364, _5186)) + 9.9999997473787516355514526367188e-06)))) * _5186) * buffer.u_DirLightsColor[0].xyz) * _5158) * 1.0);
        _13251 = _4075 + ((((_3779 * buffer.u_DirLightsColor[0].xyz) * _5158) * (_5186 * 0.31830990314483642578125)) * 1.0);
    }
    else
    {
        _13252 = _4082;
        _13251 = _4075;
    }
    float3 _5412 = fast::normalize(-buffer.u_DirLightsDirection[1].xyz);
    float _5426 = (buffer.u_DirLightsIntensity[1] * buffer.u_DirLightsEnabled[1]) * 3.1415920257568359375;
    float3 _5440 = fast::normalize(_5412 + _3732);
    float _5454 = fast::max(0.0, dot(_12985, _5412));
    float _5461 = fast::max(0.0, dot(_12985, _5440));
    float3 _13451;
    float3 _13452;
    if (buffer.u_DirLightsEnabled[1] > 0.5)
    {
        float _5597 = 1.0 - fast::max(0.0, fast::max(0.0, dot(_3732, _5440)));
        float _5611 = _5597 * _5597;
        float _5629 = fma(fma(_5461, _3839, -_5461), _5461, 1.0);
        _13452 = _13252 + ((((((_3808 + ((float3(1.0) - _3808) * ((_5611 * _5611) * _5597))) * (((_3839 * 0.31830990314483642578125) / fma(_5629, _5629, 1.0000000116860974230803549289703e-07)) * 0.25)) * _5454) * buffer.u_DirLightsColor[1].xyz) * _5426) * 1.0);
        _13451 = _13251 + ((((_3779 * buffer.u_DirLightsColor[1].xyz) * _5426) * (_5454 * 0.31830990314483642578125)) * 1.0);
    }
    else
    {
        _13452 = _13252;
        _13451 = _13251;
    }
    float3 _5649 = fast::normalize(-buffer.u_DirLightsDirection[2].xyz);
    float _5663 = (buffer.u_DirLightsIntensity[2] * buffer.u_DirLightsEnabled[2]) * 3.1415920257568359375;
    float3 _5677 = fast::normalize(_5649 + _3732);
    float _5691 = fast::max(0.0, dot(_12985, _5649));
    float _5698 = fast::max(0.0, dot(_12985, _5677));
    float3 _13662;
    float3 _13663;
    if (buffer.u_DirLightsEnabled[2] > 0.5)
    {
        float _5834 = 1.0 - fast::max(0.0, fast::max(0.0, dot(_3732, _5677)));
        float _5848 = _5834 * _5834;
        float _5866 = fma(fma(_5698, _3839, -_5698), _5698, 1.0);
        _13663 = _13452 + ((((((_3808 + ((float3(1.0) - _3808) * ((_5848 * _5848) * _5834))) * (((_3839 * 0.31830990314483642578125) / fma(_5866, _5866, 1.0000000116860974230803549289703e-07)) * 0.25)) * _5691) * buffer.u_DirLightsColor[2].xyz) * _5663) * 1.0);
        _13662 = _13451 + ((((_3779 * buffer.u_DirLightsColor[2].xyz) * _5663) * (_5691 * 0.31830990314483642578125)) * 1.0);
    }
    else
    {
        _13663 = _13452;
        _13662 = _13451;
    }
    float3 _5895 = buffer.u_PointLightsPosition[0].xyz - in.v_posWS;
    float _5897 = length(_5895);
    float3 _5901 = _5895 / float3(_5897);
    float _5915 = (buffer.u_PointLightsIntensity[0] * buffer.u_PointLightsEnabled[0]) * 3.1415920257568359375;
    float _5922 = _5897 * buffer.u_PointLightsAttenRangeInv[0];
    float _5948 = _5922 * _5922;
    float _5955 = fast::clamp(fma(-_5948, _5948, 1.0), 0.0, 1.0);
    float3 _5936 = float3(((_5955 * _5955) * fma(_5922, _5922, 1.0)) * 0.25);
    float3 _5972 = fast::normalize(_5901 + _3732);
    float _5986 = fast::max(0.0, dot(_12985, _5901));
    float _5993 = fast::max(0.0, dot(_12985, _5972));
    float3 _13884;
    float3 _13885;
    if (buffer.u_PointLightsEnabled[0] > 0.5)
    {
        float _6137 = 1.0 - fast::max(0.0, fast::max(0.0, dot(_3732, _5972)));
        float _6151 = _6137 * _6137;
        float _6164 = 1.0 - _5986;
        float _6192 = fma(fma(_5993, _3839, -_5993), _5993, 1.0);
        _13885 = _13663 + (((((((_3808 + ((float3(1.0) - _3808) * ((_6151 * _6151) * _6137))) * (((_3839 * 0.31830990314483642578125) / fma(_6192, _6192, 1.0000000116860974230803549289703e-07)) * (0.5 / (fma(_3834, fma(_3790, _6164, _5986), _3790 * fma(_3834, _6164, _5986)) + 9.9999997473787516355514526367188e-06)))) * _5986) * buffer.u_PointLightsColor[0].xyz) * _5915) * _5936) * 1.0);
        _13884 = _13662 + (((((_3779 * buffer.u_PointLightsColor[0].xyz) * _5915) * _5936) * (_5986 * 0.31830990314483642578125)) * 1.0);
    }
    else
    {
        _13885 = _13663;
        _13884 = _13662;
    }
    float3 _6221 = buffer.u_PointLightsPosition[1].xyz - in.v_posWS;
    float _6223 = length(_6221);
    float3 _6227 = _6221 / float3(_6223);
    float _6241 = (buffer.u_PointLightsIntensity[1] * buffer.u_PointLightsEnabled[1]) * 3.1415920257568359375;
    float _6248 = _6223 * buffer.u_PointLightsAttenRangeInv[1];
    float _6274 = _6248 * _6248;
    float _6281 = fast::clamp(fma(-_6274, _6274, 1.0), 0.0, 1.0);
    float3 _6262 = float3(((_6281 * _6281) * fma(_6248, _6248, 1.0)) * 0.25);
    float3 _6298 = fast::normalize(_6227 + _3732);
    float _6312 = fast::max(0.0, dot(_12985, _6227));
    float _6319 = fast::max(0.0, dot(_12985, _6298));
    float3 _14117;
    float3 _14118;
    if (buffer.u_PointLightsEnabled[1] > 0.5)
    {
        float _6455 = 1.0 - fast::max(0.0, fast::max(0.0, dot(_3732, _6298)));
        float _6469 = _6455 * _6455;
        float _6487 = fma(fma(_6319, _3839, -_6319), _6319, 1.0);
        _14118 = _13885 + (((((((_3808 + ((float3(1.0) - _3808) * ((_6469 * _6469) * _6455))) * (((_3839 * 0.31830990314483642578125) / fma(_6487, _6487, 1.0000000116860974230803549289703e-07)) * 0.25)) * _6312) * buffer.u_PointLightsColor[1].xyz) * _6241) * _6262) * 1.0);
        _14117 = _13884 + (((((_3779 * buffer.u_PointLightsColor[1].xyz) * _6241) * _6262) * (_6312 * 0.31830990314483642578125)) * 1.0);
    }
    else
    {
        _14118 = _13885;
        _14117 = _13884;
    }
    float3 _6518 = buffer.u_SpotLightsPosition[0].xyz - in.v_posWS;
    float _6520 = length(_6518);
    float3 _6524 = _6518 / float3(_6520);
    float _6538 = (buffer.u_SpotLightsIntensity[0] * buffer.u_SpotLightsEnabled[0]) * 3.1415920257568359375;
    float _6545 = _6520 * buffer.u_SpotLightsAttenRangeInv[0];
    float _6592 = _6545 * _6545;
    float _6599 = fast::clamp(fma(-_6592, _6592, 1.0), 0.0, 1.0);
    float3 _6580 = float3((((_6599 * _6599) * fma(_6545, _6545, 1.0)) * 0.25) * smoothstep(buffer.u_SpotLightsOuterAngleCos[0], buffer.u_SpotLightsInnerAngleCos[0], fast::max(0.0, dot(_6524, fast::normalize(-buffer.u_SpotLightsDirection[0].xyz)))));
    float3 _6616 = fast::normalize(_6524 + _3732);
    float _6630 = fast::max(0.0, dot(_12985, _6524));
    float _6637 = fast::max(0.0, dot(_12985, _6616));
    float3 _14361;
    float3 _14362;
    if (buffer.u_SpotLightsEnabled[0] > 0.5)
    {
        float _6781 = 1.0 - fast::max(0.0, fast::max(0.0, dot(_3732, _6616)));
        float _6795 = _6781 * _6781;
        float _6808 = 1.0 - _6630;
        float _6836 = fma(fma(_6637, _3839, -_6637), _6637, 1.0);
        _14362 = _14118 + (((((((_3808 + ((float3(1.0) - _3808) * ((_6795 * _6795) * _6781))) * (((_3839 * 0.31830990314483642578125) / fma(_6836, _6836, 1.0000000116860974230803549289703e-07)) * (0.5 / (fma(_3834, fma(_3790, _6808, _6630), _3790 * fma(_3834, _6808, _6630)) + 9.9999997473787516355514526367188e-06)))) * _6630) * buffer.u_SpotLightsColor[0].xyz) * _6538) * _6580) * 1.0);
        _14361 = _14117 + (((((_3779 * buffer.u_SpotLightsColor[0].xyz) * _6538) * _6580) * (_6630 * 0.31830990314483642578125)) * 1.0);
    }
    else
    {
        _14362 = _14118;
        _14361 = _14117;
    }
    float3 _6867 = buffer.u_SpotLightsPosition[1].xyz - in.v_posWS;
    float _6869 = length(_6867);
    float3 _6873 = _6867 / float3(_6869);
    float _6887 = (buffer.u_SpotLightsIntensity[1] * buffer.u_SpotLightsEnabled[1]) * 3.1415920257568359375;
    float _6894 = _6869 * buffer.u_SpotLightsAttenRangeInv[1];
    float _6941 = _6894 * _6894;
    float _6948 = fast::clamp(fma(-_6941, _6941, 1.0), 0.0, 1.0);
    float3 _6929 = float3((((_6948 * _6948) * fma(_6894, _6894, 1.0)) * 0.25) * smoothstep(buffer.u_SpotLightsOuterAngleCos[1], buffer.u_SpotLightsInnerAngleCos[1], fast::max(0.0, dot(_6873, fast::normalize(-buffer.u_SpotLightsDirection[1].xyz)))));
    float3 _6965 = fast::normalize(_6873 + _3732);
    float _6979 = fast::max(0.0, dot(_12985, _6873));
    float _6986 = fast::max(0.0, dot(_12985, _6965));
    float3 _14616;
    float3 _14617;
    if (buffer.u_SpotLightsEnabled[1] > 0.5)
    {
        float _7122 = 1.0 - fast::max(0.0, fast::max(0.0, dot(_3732, _6965)));
        float _7136 = _7122 * _7122;
        float _7154 = fma(fma(_6986, _3839, -_6986), _6986, 1.0);
        _14617 = _14362 + (((((((_3808 + ((float3(1.0) - _3808) * ((_7136 * _7136) * _7122))) * (((_3839 * 0.31830990314483642578125) / fma(_7154, _7154, 1.0000000116860974230803549289703e-07)) * 0.25)) * _6979) * buffer.u_SpotLightsColor[1].xyz) * _6887) * _6929) * 1.0);
        _14616 = _14361 + (((((_3779 * buffer.u_SpotLightsColor[1].xyz) * _6887) * _6929) * (_6979 * 0.31830990314483642578125)) * 1.0);
    }
    else
    {
        _14617 = _14362;
        _14616 = _14361;
    }
    float _7184 = (buffer.u_AreaLightsIntensity[0] * buffer.u_AreaLightsEnabled[0]) * 3.1415920257568359375;
    float3 _15378;
    float3 _15419;
    if (buffer.u_AreaLightsEnabled[0] > 0.5)
    {
        float3 _7344;
        float3 _7348;
        bool _7351;
        float3 _14971;
        do
        {
            _7344 = fast::normalize(_3732 - (_12985 * _3790));
            _7348 = cross(_12985, _7344);
            _7351 = buffer.u_AreaLightsShape[0] > 0.5;
            if (_7351)
            {
                float3x3 _7370 = transpose(float3x3(_7344, _7348, _12985));
                float3 _7377 = _7370 * (buffer.u_AreaLightsPoint0[0].xyz - in.v_posWS);
                float3 _7385 = _7370 * (buffer.u_AreaLightsPoint1[0].xyz - in.v_posWS);
                float3 _7393 = _7370 * (buffer.u_AreaLightsPoint2[0].xyz - in.v_posWS);
                float3 _7415 = float3x3(float3(1.0, 0.0, 0.0), float3(0.0, 1.0, 0.0), float3(0.0, 0.0, 1.0)) * ((_7377 + _7393) * 0.5);
                float3 _7418 = float3x3(float3(1.0, 0.0, 0.0), float3(0.0, 1.0, 0.0), float3(0.0, 0.0, 1.0)) * ((_7385 - _7393) * 0.5);
                float3 _7421 = float3x3(float3(1.0, 0.0, 0.0), float3(0.0, 1.0, 0.0), float3(0.0, 0.0, 1.0)) * ((_7385 - _7377) * 0.5);
                if (buffer.u_AreaLightsTwoSide[0] < 0.5)
                {
                    if (dot(cross(_7418, _7421), _7415) < 0.0)
                    {
                        _14971 = float3(0.0);
                        break;
                    }
                }
                float _7437 = dot(_7418, _7418);
                float _7440 = dot(_7421, _7421);
                float _7443 = dot(_7418, _7421);
                float _7448 = _7437 * _7440;
                float3 _14926;
                float3 _14927;
                float _14932;
                float _14934;
                if ((abs(_7443) / sqrt(_7448)) > 9.9999997473787516355514526367188e-05)
                {
                    float _7455 = _7437 + _7440;
                    float _7465 = sqrt(fma(-_7443, _7443, _7448));
                    float _7470 = sqrt(fma(-2.0, _7465, _7455));
                    float _7476 = sqrt(fma(2.0, _7465, _7455));
                    float _7480 = fma(0.5, _7470, 0.5 * _7476);
                    float _7484 = fma(0.5, _7470, _7476 * (-0.5));
                    float3 _14924;
                    float3 _14925;
                    if (_7437 > _7440)
                    {
                        float3 _7492 = _7418 * _7443;
                        float _16034 = -_7437;
                        _14925 = _7492 + (_7421 * fma(_7484, _7484, _16034));
                        _14924 = _7492 + (_7421 * fma(_7480, _7480, _16034));
                    }
                    else
                    {
                        float3 _7511 = _7421 * _7443;
                        float _16032 = -_7440;
                        _14925 = _7511 + (_7418 * fma(_7484, _7484, _16032));
                        _14924 = _7511 + (_7418 * fma(_7480, _7480, _16032));
                    }
                    _14934 = 1.0 / (_7484 * _7484);
                    _14932 = 1.0 / (_7480 * _7480);
                    _14927 = fast::normalize(_14925);
                    _14926 = fast::normalize(_14924);
                }
                else
                {
                    float _7540 = 1.0 / _7437;
                    float _7544 = 1.0 / _7440;
                    _14934 = _7544;
                    _14932 = _7540;
                    _14927 = _7421 * sqrt(_7544);
                    _14926 = _7418 * sqrt(_7540);
                }
                float3 _7556 = cross(_14926, _14927);
                float3 _14928;
                if (dot(_7415, _7556) < 0.0)
                {
                    _14928 = _7556 * (-1.0);
                }
                else
                {
                    _14928 = _7556;
                }
                float _7567 = dot(_14928, _7415);
                float _7572 = dot(_14926, _7415) / _7567;
                float _7577 = dot(_14927, _7415) / _7567;
                float _7584 = _7567 * _7567;
                float _7586 = _14932 * _7584;
                float _7591 = _14934 * _7584;
                float _7594 = _7586 * _7591;
                float _7601 = fma(_7572, _7572, 1.0);
                float _16036 = -_7586;
                float4 _12760 = _16073;
                _12760.x = _7594;
                float4 _12762 = _12760;
                _12762.y = fma(-_14934, _7584, fma(_7594, fma(_7577, _7577, _7601), _16036));
                float4 _12764 = _12762;
                _12764.z = fma(-_7591, fma(_7577, _7577, 1.0), fma(_16036, _7601, 1.0));
                float2 _7908 = _12764.yz * float2(0.3333333432674407958984375);
                float _7910 = _7908.x;
                float4 _12766 = _12764;
                _12766.y = _7910;
                float _7912 = _7908.y;
                float _7923 = -_7912;
                float _7929 = fma(_7923, _7912, _7910);
                float _7932 = -_7910;
                float _7938 = fma(_7932, _7912, _7594);
                float _7947 = dot(float2(_7912, _7932), _12766.xy);
                float _7970 = sqrt(dot(float2(4.0 * _7929, -_7938), float3(_7929, _7938, _7947).zy));
                float _7973 = precise::atan2(_7970, -fma((-2.0) * _7912, _7929, _7938));
                float _7978 = 2.0 * sqrt(-_7929);
                float _7980 = cos(_7973 * 0.3333333432674407958984375);
                float _7989 = _7978 * cos(fma(_7973, 0.3333333432674407958984375, 2.094395160675048828125));
                float _8003 = ((fma(_7978, _7980, _7989) > (2.0 * _7912)) ? (_7978 * _7980) : _7989) - _7912;
                float _8010 = -_7594;
                float _8015 = 2.0 * _7910;
                float _8026 = precise::atan2(_7594 * _7970, -fma(_8010, _7938, _8015 * _7947));
                float _8031 = 2.0 * sqrt(-_7947);
                float _8033 = cos(_8026 * 0.3333333432674407958984375);
                float _8042 = _8031 * cos(fma(_8026, 0.3333333432674407958984375, 2.094395160675048828125));
                float _8058 = ((fma(_8031, _8033, _8042) < _8015) ? (_8031 * _8033) : _8042) + _7910;
                float _8076 = fma(-_8003, _8058, _7594);
                float _8102 = _8010 / _8058;
                float _8107 = fma(_7910, _8076, -(_7912 * (_8003 * _8010))) / fma(_7923, _8076, _7910 * _8058);
                float3 _8113 = float3(_8102, _8107, _8003);
                bool _8118 = _8102 < _8107;
                bool _8126;
                if (_8118)
                {
                    _8126 = _8102 < _8003;
                }
                else
                {
                    _8126 = _8118;
                }
                float3 _14939;
                if (_8126)
                {
                    _14939 = _8113.yxz;
                }
                else
                {
                    bool _8135 = _8003 < _8102;
                    bool _8143;
                    if (_8135)
                    {
                        _8143 = _8003 < _8107;
                    }
                    else
                    {
                        _8143 = _8135;
                    }
                    float3 _14940;
                    if (_8143)
                    {
                        _14940 = _8113.xzy;
                    }
                    else
                    {
                        _14940 = _8113;
                    }
                    _14939 = _14940;
                }
                float _16044 = -_14939.y;
                float _7677 = sqrt(_16044 / _14939.z);
                float _7682 = sqrt(_16044 / _14939.x);
                float _7696 = (_7677 * _7682) * rsqrt(fma(_7677, _7677, 1.0) * fma(_7682, _7682, 1.0));
                _14971 = float3(_7696 * u_ltc_mag.sample(u_ltc_magSmplr, ((float2(fma(fast::normalize(float3x3(_14926, _14927, _14928) * float3((_7586 * _7572) / fma(_14932, _7584, _16044), (_7591 * _7577) / fma(_14934, _7584, _16044), 1.0)).z, 0.5, 0.5), _7696) * 0.984375) + float2(0.0078125))).w);
                break;
            }
            else
            {
                float3x3 _7736 = float3x3(float3(1.0, 0.0, 0.0), float3(0.0, 1.0, 0.0), float3(0.0, 0.0, 1.0)) * transpose(float3x3(_7344, _7348, _12985));
                float3 _7743 = _7736 * (buffer.u_AreaLightsPoint0[0].xyz - in.v_posWS);
                float3 _7751 = _7736 * (buffer.u_AreaLightsPoint1[0].xyz - in.v_posWS);
                float3 _7759 = _7736 * (buffer.u_AreaLightsPoint2[0].xyz - in.v_posWS);
                float3 _7767 = _7736 * (buffer.u_AreaLightsPoint3[0].xyz - in.v_posWS);
                float _8153 = _7743.z;
                int _16074 = int(_8153 > 0.0);
                float _8160 = _7751.z;
                int _14766;
                if (_8160 > 0.0)
                {
                    _14766 = _16074 + 2;
                }
                else
                {
                    _14766 = _16074;
                }
                float _8167 = _7759.z;
                int _14770;
                if (_8167 > 0.0)
                {
                    _14770 = _14766 + 4;
                }
                else
                {
                    _14770 = _14766;
                }
                float _8174 = _7767.z;
                int _14771;
                if (_8174 > 0.0)
                {
                    _14771 = _14770 + 8;
                }
                else
                {
                    _14771 = _14770;
                }
                int _14782;
                float3 _14798;
                float3 _14818;
                float3 _14840;
                float3 _14858;
                float3 _14876;
                if (_14771 == 0)
                {
                    _14876 = _7751;
                    _14858 = _7759;
                    _14840 = _7767;
                    _14818 = _12987;
                    _14798 = _7743;
                    _14782 = 0;
                }
                else
                {
                    int _14783;
                    float3 _14799;
                    float3 _14823;
                    float3 _14841;
                    float3 _14859;
                    float3 _14877;
                    if (_14771 == 1)
                    {
                        _14877 = (_7743 * (-_8160)) + (_7751 * _8153);
                        _14859 = (_7743 * (-_8174)) + (_7767 * _8153);
                        _14841 = _7767;
                        _14823 = _12987;
                        _14799 = _7743;
                        _14783 = 3;
                    }
                    else
                    {
                        int _14784;
                        float3 _14800;
                        float3 _14824;
                        float3 _14842;
                        float3 _14860;
                        float3 _14878;
                        if (_14771 == 2)
                        {
                            _14878 = _7751;
                            _14860 = (_7751 * (-_8167)) + (_7759 * _8160);
                            _14842 = _7767;
                            _14824 = _12987;
                            _14800 = (_7751 * (-_8153)) + (_7743 * _8160);
                            _14784 = 3;
                        }
                        else
                        {
                            int _14785;
                            float3 _14801;
                            float3 _14825;
                            float3 _14843;
                            float3 _14861;
                            float3 _14879;
                            if (_14771 == 3)
                            {
                                _14879 = _7751;
                                _14861 = (_7751 * (-_8167)) + (_7759 * _8160);
                                _14843 = (_7743 * (-_8174)) + (_7767 * _8153);
                                _14825 = _12987;
                                _14801 = _7743;
                                _14785 = 4;
                            }
                            else
                            {
                                int _14786;
                                float3 _14802;
                                float3 _14826;
                                float3 _14844;
                                float3 _14862;
                                float3 _14880;
                                if (_14771 == 4)
                                {
                                    _14880 = (_7759 * (-_8160)) + (_7751 * _8167);
                                    _14862 = _7759;
                                    _14844 = _7767;
                                    _14826 = _12987;
                                    _14802 = (_7759 * (-_8174)) + (_7767 * _8167);
                                    _14786 = 3;
                                }
                                else
                                {
                                    int _14787;
                                    float3 _14803;
                                    float3 _14827;
                                    float3 _14845;
                                    float3 _14863;
                                    float3 _14881;
                                    if (_14771 == 5)
                                    {
                                        _14881 = _7751;
                                        _14863 = _7759;
                                        _14845 = _7767;
                                        _14827 = _12987;
                                        _14803 = _7743;
                                        _14787 = 0;
                                    }
                                    else
                                    {
                                        int _14788;
                                        float3 _14804;
                                        float3 _14828;
                                        float3 _14846;
                                        float3 _14864;
                                        float3 _14882;
                                        if (_14771 == 6)
                                        {
                                            _14882 = _7751;
                                            _14864 = _7759;
                                            _14846 = (_7759 * (-_8174)) + (_7767 * _8167);
                                            _14828 = _12987;
                                            _14804 = (_7751 * (-_8153)) + (_7743 * _8160);
                                            _14788 = 4;
                                        }
                                        else
                                        {
                                            int _14789;
                                            float3 _14805;
                                            float3 _14829;
                                            float3 _14847;
                                            float3 _14865;
                                            float3 _14883;
                                            if (_14771 == 7)
                                            {
                                                float _8343 = -_8174;
                                                _14883 = _7751;
                                                _14865 = _7759;
                                                _14847 = (_7759 * _8343) + (_7767 * _8167);
                                                _14829 = (_7743 * _8343) + (_7767 * _8153);
                                                _14805 = _7743;
                                                _14789 = 5;
                                            }
                                            else
                                            {
                                                int _14790;
                                                float3 _14806;
                                                float3 _14830;
                                                float3 _14848;
                                                float3 _14866;
                                                float3 _14884;
                                                if (_14771 == 8)
                                                {
                                                    _14884 = (_7767 * (-_8167)) + (_7759 * _8174);
                                                    _14866 = _7767;
                                                    _14848 = _7767;
                                                    _14830 = _12987;
                                                    _14806 = (_7767 * (-_8153)) + (_7743 * _8174);
                                                    _14790 = 3;
                                                }
                                                else
                                                {
                                                    int _14791;
                                                    float3 _14807;
                                                    float3 _14831;
                                                    float3 _14849;
                                                    float3 _14867;
                                                    float3 _14885;
                                                    if (_14771 == 9)
                                                    {
                                                        _14885 = (_7743 * (-_8160)) + (_7751 * _8153);
                                                        _14867 = (_7767 * (-_8167)) + (_7759 * _8174);
                                                        _14849 = _7767;
                                                        _14831 = _12987;
                                                        _14807 = _7743;
                                                        _14791 = 4;
                                                    }
                                                    else
                                                    {
                                                        int _14792;
                                                        float3 _14808;
                                                        float3 _14832;
                                                        float3 _14850;
                                                        float3 _14868;
                                                        float3 _14886;
                                                        if (_14771 == 10)
                                                        {
                                                            _14886 = _7751;
                                                            _14868 = _7759;
                                                            _14850 = _7767;
                                                            _14832 = _12987;
                                                            _14808 = _7743;
                                                            _14792 = 0;
                                                        }
                                                        else
                                                        {
                                                            int _14793;
                                                            float3 _14809;
                                                            float3 _14833;
                                                            float3 _14851;
                                                            float3 _14869;
                                                            float3 _14887;
                                                            if (_14771 == 11)
                                                            {
                                                                float _8443 = -_8167;
                                                                _14887 = _7751;
                                                                _14869 = (_7751 * _8443) + (_7759 * _8160);
                                                                _14851 = (_7767 * _8443) + (_7759 * _8174);
                                                                _14833 = _7767;
                                                                _14809 = _7743;
                                                                _14793 = 5;
                                                            }
                                                            else
                                                            {
                                                                int _14794;
                                                                float3 _14810;
                                                                float3 _14834;
                                                                float3 _14852;
                                                                float3 _14870;
                                                                float3 _14888;
                                                                if (_14771 == 12)
                                                                {
                                                                    _14888 = (_7759 * (-_8160)) + (_7751 * _8167);
                                                                    _14870 = _7759;
                                                                    _14852 = _7767;
                                                                    _14834 = _12987;
                                                                    _14810 = (_7767 * (-_8153)) + (_7743 * _8174);
                                                                    _14794 = 4;
                                                                }
                                                                else
                                                                {
                                                                    bool _8499 = _14771 == 13;
                                                                    int _14795;
                                                                    float3 _14811;
                                                                    float3 _14835;
                                                                    float3 _14871;
                                                                    float3 _14889;
                                                                    if (_8499)
                                                                    {
                                                                        float _8509 = -_8160;
                                                                        _14889 = (_7743 * _8509) + (_7751 * _8153);
                                                                        _14871 = (_7759 * _8509) + (_7751 * _8167);
                                                                        _14835 = _7767;
                                                                        _14811 = _7743;
                                                                        _14795 = 5;
                                                                    }
                                                                    else
                                                                    {
                                                                        int _14796;
                                                                        float3 _14812;
                                                                        float3 _14836;
                                                                        if (_14771 == 14)
                                                                        {
                                                                            float _8539 = -_8153;
                                                                            _14836 = (_7767 * _8539) + (_7743 * _8174);
                                                                            _14812 = (_7751 * _8539) + (_7743 * _8160);
                                                                            _14796 = 5;
                                                                        }
                                                                        else
                                                                        {
                                                                            _14836 = _12987;
                                                                            _14812 = _7743;
                                                                            _14796 = (_14771 == 15) ? 4 : 0;
                                                                        }
                                                                        _14889 = _7751;
                                                                        _14871 = _7759;
                                                                        _14835 = _14836;
                                                                        _14811 = _14812;
                                                                        _14795 = _14796;
                                                                    }
                                                                    _14888 = _14889;
                                                                    _14870 = _14871;
                                                                    _14852 = select(_7767, _7759, bool3(_8499));
                                                                    _14834 = _14835;
                                                                    _14810 = _14811;
                                                                    _14794 = _14795;
                                                                }
                                                                _14887 = _14888;
                                                                _14869 = _14870;
                                                                _14851 = _14852;
                                                                _14833 = _14834;
                                                                _14809 = _14810;
                                                                _14793 = _14794;
                                                            }
                                                            _14886 = _14887;
                                                            _14868 = _14869;
                                                            _14850 = _14851;
                                                            _14832 = _14833;
                                                            _14808 = _14809;
                                                            _14792 = _14793;
                                                        }
                                                        _14885 = _14886;
                                                        _14867 = _14868;
                                                        _14849 = _14850;
                                                        _14831 = _14832;
                                                        _14807 = _14808;
                                                        _14791 = _14792;
                                                    }
                                                    _14884 = _14885;
                                                    _14866 = _14867;
                                                    _14848 = _14849;
                                                    _14830 = _14831;
                                                    _14806 = _14807;
                                                    _14790 = _14791;
                                                }
                                                _14883 = _14884;
                                                _14865 = _14866;
                                                _14847 = _14848;
                                                _14829 = _14830;
                                                _14805 = _14806;
                                                _14789 = _14790;
                                            }
                                            _14882 = _14883;
                                            _14864 = _14865;
                                            _14846 = _14847;
                                            _14828 = _14829;
                                            _14804 = _14805;
                                            _14788 = _14789;
                                        }
                                        _14881 = _14882;
                                        _14863 = _14864;
                                        _14845 = _14846;
                                        _14827 = _14828;
                                        _14803 = _14804;
                                        _14787 = _14788;
                                    }
                                    _14880 = _14881;
                                    _14862 = _14863;
                                    _14844 = _14845;
                                    _14826 = _14827;
                                    _14802 = _14803;
                                    _14786 = _14787;
                                }
                                _14879 = _14880;
                                _14861 = _14862;
                                _14843 = _14844;
                                _14825 = _14826;
                                _14801 = _14802;
                                _14785 = _14786;
                            }
                            _14878 = _14879;
                            _14860 = _14861;
                            _14842 = _14843;
                            _14824 = _14825;
                            _14800 = _14801;
                            _14784 = _14785;
                        }
                        _14877 = _14878;
                        _14859 = _14860;
                        _14841 = _14842;
                        _14823 = _14824;
                        _14799 = _14800;
                        _14783 = _14784;
                    }
                    _14876 = _14877;
                    _14858 = _14859;
                    _14840 = _14841;
                    _14818 = _14823;
                    _14798 = _14799;
                    _14782 = _14783;
                }
                if (_14782 == 0)
                {
                    _14971 = float3(0.0);
                    break;
                }
                float3 _7779 = fast::normalize(_14798);
                float3 _7783 = fast::normalize(_14876);
                float3 _7787 = fast::normalize(_14858);
                float3 _7791 = fast::normalize(select(_14840, _14798, bool3(_14782 == 3)));
                float3 _7795 = fast::normalize(select(_14818, _14798, bool3(_14782 == 4)));
                float _8616 = dot(_7779, _7783);
                float _8618 = abs(_8616);
                float _8632 = fma(fma(0.01452060043811798095703125, _8618, 0.4965155124664306640625), _8618, 0.8543984889984130859375) / fma(4.1616725921630859375 + _8618, _8618, 3.41759395599365234375);
                float _14894;
                if (_8616 > 0.0)
                {
                    _14894 = _8632;
                }
                else
                {
                    _14894 = fma(0.5, rsqrt(fast::max(fma(-_8616, _8616, 1.0), 1.0000000116860974230803549289703e-07)), -_8632);
                }
                float _8673 = dot(_7783, _7787);
                float _8675 = abs(_8673);
                float _8689 = fma(fma(0.01452060043811798095703125, _8675, 0.4965155124664306640625), _8675, 0.8543984889984130859375) / fma(4.1616725921630859375 + _8675, _8675, 3.41759395599365234375);
                float _14898;
                if (_8673 > 0.0)
                {
                    _14898 = _8689;
                }
                else
                {
                    _14898 = fma(0.5, rsqrt(fast::max(fma(-_8673, _8673, 1.0), 1.0000000116860974230803549289703e-07)), -_8689);
                }
                float _8730 = dot(_7787, _7791);
                float _8732 = abs(_8730);
                float _8746 = fma(fma(0.01452060043811798095703125, _8732, 0.4965155124664306640625), _8732, 0.8543984889984130859375) / fma(4.1616725921630859375 + _8732, _8732, 3.41759395599365234375);
                float _14903;
                if (_8730 > 0.0)
                {
                    _14903 = _8746;
                }
                else
                {
                    _14903 = fma(0.5, rsqrt(fast::max(fma(-_8730, _8730, 1.0), 1.0000000116860974230803549289703e-07)), -_8746);
                }
                float _7817 = ((cross(_7779, _7783) * _14894).z + (cross(_7783, _7787) * _14898).z) + (cross(_7787, _7791) * _14903).z;
                float _14920;
                if (_14782 >= 4)
                {
                    float _8787 = dot(_7791, _7795);
                    float _8789 = abs(_8787);
                    float _8803 = fma(fma(0.01452060043811798095703125, _8789, 0.4965155124664306640625), _8789, 0.8543984889984130859375) / fma(4.1616725921630859375 + _8789, _8789, 3.41759395599365234375);
                    float _14909;
                    if (_8787 > 0.0)
                    {
                        _14909 = _8803;
                    }
                    else
                    {
                        _14909 = fma(0.5, rsqrt(fast::max(fma(-_8787, _8787, 1.0), 1.0000000116860974230803549289703e-07)), -_8803);
                    }
                    _14920 = _7817 + (cross(_7791, _7795) * _14909).z;
                }
                else
                {
                    _14920 = _7817;
                }
                float _14921;
                if (_14782 == 5)
                {
                    float _8844 = dot(_7795, _7779);
                    float _8846 = abs(_8844);
                    float _8860 = fma(fma(0.01452060043811798095703125, _8846, 0.4965155124664306640625), _8846, 0.8543984889984130859375) / fma(4.1616725921630859375 + _8846, _8846, 3.41759395599365234375);
                    float _14918;
                    if (_8844 > 0.0)
                    {
                        _14918 = _8860;
                    }
                    else
                    {
                        _14918 = fma(0.5, rsqrt(fast::max(fma(-_8844, _8844, 1.0), 1.0000000116860974230803549289703e-07)), -_8860);
                    }
                    _14921 = _14920 + (cross(_7795, _7779) * _14918).z;
                }
                else
                {
                    _14921 = _14920;
                }
                if (buffer.u_AreaLightsTwoSide[0] > 0.5)
                {
                    _14971 = float3(abs(_14921));
                    break;
                }
                _14971 = float3(fast::max(0.0, _14921));
                break;
            }
        } while(false);
        float2 _8904 = fast::clamp((float2(_3765, sqrt(1.0 - _3790)) * 0.984375) + float2(0.0078125), float2(0.0), float2(1.0));
        float4 _8964 = u_ltc_mat.sample(u_ltc_matSmplr, _8904);
        float4 _8968 = (_8964 - float4(0.5)) * 4.0;
        float3x3 _8991 = float3x3(float3(_8968.x, 0.0, _8968.y), float3(0.0, 1.0, 0.0), float3(_8968.z, 0.0, _8968.w));
        float4 _8997 = u_ltc_mag.sample(u_ltc_magSmplr, _8904);
        float3 _15285;
        do
        {
            if (_7351)
            {
                float3x3 _9099 = transpose(float3x3(_7344, _7348, _12985));
                float3 _9106 = _9099 * (buffer.u_AreaLightsPoint0[0].xyz - in.v_posWS);
                float3 _9114 = _9099 * (buffer.u_AreaLightsPoint1[0].xyz - in.v_posWS);
                float3 _9122 = _9099 * (buffer.u_AreaLightsPoint2[0].xyz - in.v_posWS);
                float3 _9144 = _8991 * ((_9106 + _9122) * 0.5);
                float3 _9147 = _8991 * ((_9114 - _9122) * 0.5);
                float3 _9150 = _8991 * ((_9114 - _9106) * 0.5);
                if (buffer.u_AreaLightsTwoSide[0] < 0.5)
                {
                    if (dot(cross(_9147, _9150), _9144) < 0.0)
                    {
                        _15285 = float3(0.0);
                        break;
                    }
                }
                float _9166 = dot(_9147, _9147);
                float _9169 = dot(_9150, _9150);
                float _9172 = dot(_9147, _9150);
                float _9177 = _9166 * _9169;
                float3 _15240;
                float3 _15241;
                float _15246;
                float _15248;
                if ((abs(_9172) / sqrt(_9177)) > 9.9999997473787516355514526367188e-05)
                {
                    float _9184 = _9166 + _9169;
                    float _9194 = sqrt(fma(-_9172, _9172, _9177));
                    float _9199 = sqrt(fma(-2.0, _9194, _9184));
                    float _9205 = sqrt(fma(2.0, _9194, _9184));
                    float _9209 = fma(0.5, _9199, 0.5 * _9205);
                    float _9213 = fma(0.5, _9199, _9205 * (-0.5));
                    float3 _15238;
                    float3 _15239;
                    if (_9166 > _9169)
                    {
                        float3 _9221 = _9147 * _9172;
                        float _16060 = -_9166;
                        _15239 = _9221 + (_9150 * fma(_9213, _9213, _16060));
                        _15238 = _9221 + (_9150 * fma(_9209, _9209, _16060));
                    }
                    else
                    {
                        float3 _9240 = _9150 * _9172;
                        float _16058 = -_9169;
                        _15239 = _9240 + (_9147 * fma(_9213, _9213, _16058));
                        _15238 = _9240 + (_9147 * fma(_9209, _9209, _16058));
                    }
                    _15248 = 1.0 / (_9213 * _9213);
                    _15246 = 1.0 / (_9209 * _9209);
                    _15241 = fast::normalize(_15239);
                    _15240 = fast::normalize(_15238);
                }
                else
                {
                    float _9269 = 1.0 / _9166;
                    float _9273 = 1.0 / _9169;
                    _15248 = _9273;
                    _15246 = _9269;
                    _15241 = _9150 * sqrt(_9273);
                    _15240 = _9147 * sqrt(_9269);
                }
                float3 _9285 = cross(_15240, _15241);
                float3 _15242;
                if (dot(_9144, _9285) < 0.0)
                {
                    _15242 = _9285 * (-1.0);
                }
                else
                {
                    _15242 = _9285;
                }
                float _9296 = dot(_15242, _9144);
                float _9301 = dot(_15240, _9144) / _9296;
                float _9306 = dot(_15241, _9144) / _9296;
                float _9313 = _9296 * _9296;
                float _9315 = _15246 * _9313;
                float _9320 = _15248 * _9313;
                float _9323 = _9315 * _9320;
                float _9330 = fma(_9301, _9301, 1.0);
                float _16062 = -_9315;
                float4 _12876 = _16073;
                _12876.x = _9323;
                float4 _12878 = _12876;
                _12878.y = fma(-_15248, _9313, fma(_9323, fma(_9306, _9306, _9330), _16062));
                float4 _12880 = _12878;
                _12880.z = fma(-_9320, fma(_9306, _9306, 1.0), fma(_16062, _9330, 1.0));
                float2 _9637 = _12880.yz * float2(0.3333333432674407958984375);
                float _9639 = _9637.x;
                float4 _12882 = _12880;
                _12882.y = _9639;
                float _9641 = _9637.y;
                float _9652 = -_9641;
                float _9658 = fma(_9652, _9641, _9639);
                float _9661 = -_9639;
                float _9667 = fma(_9661, _9641, _9323);
                float _9676 = dot(float2(_9641, _9661), _12882.xy);
                float _9699 = sqrt(dot(float2(4.0 * _9658, -_9667), float3(_9658, _9667, _9676).zy));
                float _9702 = precise::atan2(_9699, -fma((-2.0) * _9641, _9658, _9667));
                float _9707 = 2.0 * sqrt(-_9658);
                float _9709 = cos(_9702 * 0.3333333432674407958984375);
                float _9718 = _9707 * cos(fma(_9702, 0.3333333432674407958984375, 2.094395160675048828125));
                float _9732 = ((fma(_9707, _9709, _9718) > (2.0 * _9641)) ? (_9707 * _9709) : _9718) - _9641;
                float _9739 = -_9323;
                float _9744 = 2.0 * _9639;
                float _9755 = precise::atan2(_9323 * _9699, -fma(_9739, _9667, _9744 * _9676));
                float _9760 = 2.0 * sqrt(-_9676);
                float _9762 = cos(_9755 * 0.3333333432674407958984375);
                float _9771 = _9760 * cos(fma(_9755, 0.3333333432674407958984375, 2.094395160675048828125));
                float _9787 = ((fma(_9760, _9762, _9771) < _9744) ? (_9760 * _9762) : _9771) + _9639;
                float _9805 = fma(-_9732, _9787, _9323);
                float _9831 = _9739 / _9787;
                float _9836 = fma(_9639, _9805, -(_9641 * (_9732 * _9739))) / fma(_9652, _9805, _9639 * _9787);
                float3 _9842 = float3(_9831, _9836, _9732);
                bool _9847 = _9831 < _9836;
                bool _9855;
                if (_9847)
                {
                    _9855 = _9831 < _9732;
                }
                else
                {
                    _9855 = _9847;
                }
                float3 _15253;
                if (_9855)
                {
                    _15253 = _9842.yxz;
                }
                else
                {
                    bool _9864 = _9732 < _9831;
                    bool _9872;
                    if (_9864)
                    {
                        _9872 = _9732 < _9836;
                    }
                    else
                    {
                        _9872 = _9864;
                    }
                    float3 _15254;
                    if (_9872)
                    {
                        _15254 = _9842.xzy;
                    }
                    else
                    {
                        _15254 = _9842;
                    }
                    _15253 = _15254;
                }
                float _16068 = -_15253.y;
                float _9406 = sqrt(_16068 / _15253.z);
                float _9411 = sqrt(_16068 / _15253.x);
                float _9425 = (_9406 * _9411) * rsqrt(fma(_9406, _9406, 1.0) * fma(_9411, _9411, 1.0));
                _15285 = float3(_9425 * u_ltc_mag.sample(u_ltc_magSmplr, ((float2(fma(fast::normalize(float3x3(_15240, _15241, _15242) * float3((_9315 * _9301) / fma(_15246, _9313, _16068), (_9320 * _9306) / fma(_15248, _9313, _16068), 1.0)).z, 0.5, 0.5), _9425) * 0.984375) + float2(0.0078125))).w);
                break;
            }
            else
            {
                float3x3 _9465 = _8991 * transpose(float3x3(_7344, _7348, _12985));
                float3 _9472 = _9465 * (buffer.u_AreaLightsPoint0[0].xyz - in.v_posWS);
                float3 _9480 = _9465 * (buffer.u_AreaLightsPoint1[0].xyz - in.v_posWS);
                float3 _9488 = _9465 * (buffer.u_AreaLightsPoint2[0].xyz - in.v_posWS);
                float3 _9496 = _9465 * (buffer.u_AreaLightsPoint3[0].xyz - in.v_posWS);
                float _9882 = _9472.z;
                int _16085 = int(_9882 > 0.0);
                float _9889 = _9480.z;
                int _15080;
                if (_9889 > 0.0)
                {
                    _15080 = _16085 + 2;
                }
                else
                {
                    _15080 = _16085;
                }
                float _9896 = _9488.z;
                int _15084;
                if (_9896 > 0.0)
                {
                    _15084 = _15080 + 4;
                }
                else
                {
                    _15084 = _15080;
                }
                float _9903 = _9496.z;
                int _15085;
                if (_9903 > 0.0)
                {
                    _15085 = _15084 + 8;
                }
                else
                {
                    _15085 = _15084;
                }
                int _15096;
                float3 _15112;
                float3 _15132;
                float3 _15154;
                float3 _15172;
                float3 _15190;
                if (_15085 == 0)
                {
                    _15190 = _9480;
                    _15172 = _9488;
                    _15154 = _9496;
                    _15132 = _12987;
                    _15112 = _9472;
                    _15096 = 0;
                }
                else
                {
                    int _15097;
                    float3 _15113;
                    float3 _15137;
                    float3 _15155;
                    float3 _15173;
                    float3 _15191;
                    if (_15085 == 1)
                    {
                        _15191 = (_9472 * (-_9889)) + (_9480 * _9882);
                        _15173 = (_9472 * (-_9903)) + (_9496 * _9882);
                        _15155 = _9496;
                        _15137 = _12987;
                        _15113 = _9472;
                        _15097 = 3;
                    }
                    else
                    {
                        int _15098;
                        float3 _15114;
                        float3 _15138;
                        float3 _15156;
                        float3 _15174;
                        float3 _15192;
                        if (_15085 == 2)
                        {
                            _15192 = _9480;
                            _15174 = (_9480 * (-_9896)) + (_9488 * _9889);
                            _15156 = _9496;
                            _15138 = _12987;
                            _15114 = (_9480 * (-_9882)) + (_9472 * _9889);
                            _15098 = 3;
                        }
                        else
                        {
                            int _15099;
                            float3 _15115;
                            float3 _15139;
                            float3 _15157;
                            float3 _15175;
                            float3 _15193;
                            if (_15085 == 3)
                            {
                                _15193 = _9480;
                                _15175 = (_9480 * (-_9896)) + (_9488 * _9889);
                                _15157 = (_9472 * (-_9903)) + (_9496 * _9882);
                                _15139 = _12987;
                                _15115 = _9472;
                                _15099 = 4;
                            }
                            else
                            {
                                int _15100;
                                float3 _15116;
                                float3 _15140;
                                float3 _15158;
                                float3 _15176;
                                float3 _15194;
                                if (_15085 == 4)
                                {
                                    _15194 = (_9488 * (-_9889)) + (_9480 * _9896);
                                    _15176 = _9488;
                                    _15158 = _9496;
                                    _15140 = _12987;
                                    _15116 = (_9488 * (-_9903)) + (_9496 * _9896);
                                    _15100 = 3;
                                }
                                else
                                {
                                    int _15101;
                                    float3 _15117;
                                    float3 _15141;
                                    float3 _15159;
                                    float3 _15177;
                                    float3 _15195;
                                    if (_15085 == 5)
                                    {
                                        _15195 = _9480;
                                        _15177 = _9488;
                                        _15159 = _9496;
                                        _15141 = _12987;
                                        _15117 = _9472;
                                        _15101 = 0;
                                    }
                                    else
                                    {
                                        int _15102;
                                        float3 _15118;
                                        float3 _15142;
                                        float3 _15160;
                                        float3 _15178;
                                        float3 _15196;
                                        if (_15085 == 6)
                                        {
                                            _15196 = _9480;
                                            _15178 = _9488;
                                            _15160 = (_9488 * (-_9903)) + (_9496 * _9896);
                                            _15142 = _12987;
                                            _15118 = (_9480 * (-_9882)) + (_9472 * _9889);
                                            _15102 = 4;
                                        }
                                        else
                                        {
                                            int _15103;
                                            float3 _15119;
                                            float3 _15143;
                                            float3 _15161;
                                            float3 _15179;
                                            float3 _15197;
                                            if (_15085 == 7)
                                            {
                                                float _10072 = -_9903;
                                                _15197 = _9480;
                                                _15179 = _9488;
                                                _15161 = (_9488 * _10072) + (_9496 * _9896);
                                                _15143 = (_9472 * _10072) + (_9496 * _9882);
                                                _15119 = _9472;
                                                _15103 = 5;
                                            }
                                            else
                                            {
                                                int _15104;
                                                float3 _15120;
                                                float3 _15144;
                                                float3 _15162;
                                                float3 _15180;
                                                float3 _15198;
                                                if (_15085 == 8)
                                                {
                                                    _15198 = (_9496 * (-_9896)) + (_9488 * _9903);
                                                    _15180 = _9496;
                                                    _15162 = _9496;
                                                    _15144 = _12987;
                                                    _15120 = (_9496 * (-_9882)) + (_9472 * _9903);
                                                    _15104 = 3;
                                                }
                                                else
                                                {
                                                    int _15105;
                                                    float3 _15121;
                                                    float3 _15145;
                                                    float3 _15163;
                                                    float3 _15181;
                                                    float3 _15199;
                                                    if (_15085 == 9)
                                                    {
                                                        _15199 = (_9472 * (-_9889)) + (_9480 * _9882);
                                                        _15181 = (_9496 * (-_9896)) + (_9488 * _9903);
                                                        _15163 = _9496;
                                                        _15145 = _12987;
                                                        _15121 = _9472;
                                                        _15105 = 4;
                                                    }
                                                    else
                                                    {
                                                        int _15106;
                                                        float3 _15122;
                                                        float3 _15146;
                                                        float3 _15164;
                                                        float3 _15182;
                                                        float3 _15200;
                                                        if (_15085 == 10)
                                                        {
                                                            _15200 = _9480;
                                                            _15182 = _9488;
                                                            _15164 = _9496;
                                                            _15146 = _12987;
                                                            _15122 = _9472;
                                                            _15106 = 0;
                                                        }
                                                        else
                                                        {
                                                            int _15107;
                                                            float3 _15123;
                                                            float3 _15147;
                                                            float3 _15165;
                                                            float3 _15183;
                                                            float3 _15201;
                                                            if (_15085 == 11)
                                                            {
                                                                float _10172 = -_9896;
                                                                _15201 = _9480;
                                                                _15183 = (_9480 * _10172) + (_9488 * _9889);
                                                                _15165 = (_9496 * _10172) + (_9488 * _9903);
                                                                _15147 = _9496;
                                                                _15123 = _9472;
                                                                _15107 = 5;
                                                            }
                                                            else
                                                            {
                                                                int _15108;
                                                                float3 _15124;
                                                                float3 _15148;
                                                                float3 _15166;
                                                                float3 _15184;
                                                                float3 _15202;
                                                                if (_15085 == 12)
                                                                {
                                                                    _15202 = (_9488 * (-_9889)) + (_9480 * _9896);
                                                                    _15184 = _9488;
                                                                    _15166 = _9496;
                                                                    _15148 = _12987;
                                                                    _15124 = (_9496 * (-_9882)) + (_9472 * _9903);
                                                                    _15108 = 4;
                                                                }
                                                                else
                                                                {
                                                                    bool _10228 = _15085 == 13;
                                                                    int _15109;
                                                                    float3 _15125;
                                                                    float3 _15149;
                                                                    float3 _15185;
                                                                    float3 _15203;
                                                                    if (_10228)
                                                                    {
                                                                        float _10238 = -_9889;
                                                                        _15203 = (_9472 * _10238) + (_9480 * _9882);
                                                                        _15185 = (_9488 * _10238) + (_9480 * _9896);
                                                                        _15149 = _9496;
                                                                        _15125 = _9472;
                                                                        _15109 = 5;
                                                                    }
                                                                    else
                                                                    {
                                                                        int _15110;
                                                                        float3 _15126;
                                                                        float3 _15150;
                                                                        if (_15085 == 14)
                                                                        {
                                                                            float _10268 = -_9882;
                                                                            _15150 = (_9496 * _10268) + (_9472 * _9903);
                                                                            _15126 = (_9480 * _10268) + (_9472 * _9889);
                                                                            _15110 = 5;
                                                                        }
                                                                        else
                                                                        {
                                                                            _15150 = _12987;
                                                                            _15126 = _9472;
                                                                            _15110 = (_15085 == 15) ? 4 : 0;
                                                                        }
                                                                        _15203 = _9480;
                                                                        _15185 = _9488;
                                                                        _15149 = _15150;
                                                                        _15125 = _15126;
                                                                        _15109 = _15110;
                                                                    }
                                                                    _15202 = _15203;
                                                                    _15184 = _15185;
                                                                    _15166 = select(_9496, _9488, bool3(_10228));
                                                                    _15148 = _15149;
                                                                    _15124 = _15125;
                                                                    _15108 = _15109;
                                                                }
                                                                _15201 = _15202;
                                                                _15183 = _15184;
                                                                _15165 = _15166;
                                                                _15147 = _15148;
                                                                _15123 = _15124;
                                                                _15107 = _15108;
                                                            }
                                                            _15200 = _15201;
                                                            _15182 = _15183;
                                                            _15164 = _15165;
                                                            _15146 = _15147;
                                                            _15122 = _15123;
                                                            _15106 = _15107;
                                                        }
                                                        _15199 = _15200;
                                                        _15181 = _15182;
                                                        _15163 = _15164;
                                                        _15145 = _15146;
                                                        _15121 = _15122;
                                                        _15105 = _15106;
                                                    }
                                                    _15198 = _15199;
                                                    _15180 = _15181;
                                                    _15162 = _15163;
                                                    _15144 = _15145;
                                                    _15120 = _15121;
                                                    _15104 = _15105;
                                                }
                                                _15197 = _15198;
                                                _15179 = _15180;
                                                _15161 = _15162;
                                                _15143 = _15144;
                                                _15119 = _15120;
                                                _15103 = _15104;
                                            }
                                            _15196 = _15197;
                                            _15178 = _15179;
                                            _15160 = _15161;
                                            _15142 = _15143;
                                            _15118 = _15119;
                                            _15102 = _15103;
                                        }
                                        _15195 = _15196;
                                        _15177 = _15178;
                                        _15159 = _15160;
                                        _15141 = _15142;
                                        _15117 = _15118;
                                        _15101 = _15102;
                                    }
                                    _15194 = _15195;
                                    _15176 = _15177;
                                    _15158 = _15159;
                                    _15140 = _15141;
                                    _15116 = _15117;
                                    _15100 = _15101;
                                }
                                _15193 = _15194;
                                _15175 = _15176;
                                _15157 = _15158;
                                _15139 = _15140;
                                _15115 = _15116;
                                _15099 = _15100;
                            }
                            _15192 = _15193;
                            _15174 = _15175;
                            _15156 = _15157;
                            _15138 = _15139;
                            _15114 = _15115;
                            _15098 = _15099;
                        }
                        _15191 = _15192;
                        _15173 = _15174;
                        _15155 = _15156;
                        _15137 = _15138;
                        _15113 = _15114;
                        _15097 = _15098;
                    }
                    _15190 = _15191;
                    _15172 = _15173;
                    _15154 = _15155;
                    _15132 = _15137;
                    _15112 = _15113;
                    _15096 = _15097;
                }
                if (_15096 == 0)
                {
                    _15285 = float3(0.0);
                    break;
                }
                float3 _9508 = fast::normalize(_15112);
                float3 _9512 = fast::normalize(_15190);
                float3 _9516 = fast::normalize(_15172);
                float3 _9520 = fast::normalize(select(_15154, _15112, bool3(_15096 == 3)));
                float3 _9524 = fast::normalize(select(_15132, _15112, bool3(_15096 == 4)));
                float _10345 = dot(_9508, _9512);
                float _10347 = abs(_10345);
                float _10361 = fma(fma(0.01452060043811798095703125, _10347, 0.4965155124664306640625), _10347, 0.8543984889984130859375) / fma(4.1616725921630859375 + _10347, _10347, 3.41759395599365234375);
                float _15208;
                if (_10345 > 0.0)
                {
                    _15208 = _10361;
                }
                else
                {
                    _15208 = fma(0.5, rsqrt(fast::max(fma(-_10345, _10345, 1.0), 1.0000000116860974230803549289703e-07)), -_10361);
                }
                float _10402 = dot(_9512, _9516);
                float _10404 = abs(_10402);
                float _10418 = fma(fma(0.01452060043811798095703125, _10404, 0.4965155124664306640625), _10404, 0.8543984889984130859375) / fma(4.1616725921630859375 + _10404, _10404, 3.41759395599365234375);
                float _15212;
                if (_10402 > 0.0)
                {
                    _15212 = _10418;
                }
                else
                {
                    _15212 = fma(0.5, rsqrt(fast::max(fma(-_10402, _10402, 1.0), 1.0000000116860974230803549289703e-07)), -_10418);
                }
                float _10459 = dot(_9516, _9520);
                float _10461 = abs(_10459);
                float _10475 = fma(fma(0.01452060043811798095703125, _10461, 0.4965155124664306640625), _10461, 0.8543984889984130859375) / fma(4.1616725921630859375 + _10461, _10461, 3.41759395599365234375);
                float _15217;
                if (_10459 > 0.0)
                {
                    _15217 = _10475;
                }
                else
                {
                    _15217 = fma(0.5, rsqrt(fast::max(fma(-_10459, _10459, 1.0), 1.0000000116860974230803549289703e-07)), -_10475);
                }
                float _9546 = ((cross(_9508, _9512) * _15208).z + (cross(_9512, _9516) * _15212).z) + (cross(_9516, _9520) * _15217).z;
                float _15234;
                if (_15096 >= 4)
                {
                    float _10516 = dot(_9520, _9524);
                    float _10518 = abs(_10516);
                    float _10532 = fma(fma(0.01452060043811798095703125, _10518, 0.4965155124664306640625), _10518, 0.8543984889984130859375) / fma(4.1616725921630859375 + _10518, _10518, 3.41759395599365234375);
                    float _15223;
                    if (_10516 > 0.0)
                    {
                        _15223 = _10532;
                    }
                    else
                    {
                        _15223 = fma(0.5, rsqrt(fast::max(fma(-_10516, _10516, 1.0), 1.0000000116860974230803549289703e-07)), -_10532);
                    }
                    _15234 = _9546 + (cross(_9520, _9524) * _15223).z;
                }
                else
                {
                    _15234 = _9546;
                }
                float _15235;
                if (_15096 == 5)
                {
                    float _10573 = dot(_9524, _9508);
                    float _10575 = abs(_10573);
                    float _10589 = fma(fma(0.01452060043811798095703125, _10575, 0.4965155124664306640625), _10575, 0.8543984889984130859375) / fma(4.1616725921630859375 + _10575, _10575, 3.41759395599365234375);
                    float _15232;
                    if (_10573 > 0.0)
                    {
                        _15232 = _10589;
                    }
                    else
                    {
                        _15232 = fma(0.5, rsqrt(fast::max(fma(-_10573, _10573, 1.0), 1.0000000116860974230803549289703e-07)), -_10589);
                    }
                    _15235 = _15234 + (cross(_9524, _9508) * _15232).z;
                }
                else
                {
                    _15235 = _15234;
                }
                if (buffer.u_AreaLightsTwoSide[0] > 0.5)
                {
                    _15285 = float3(abs(_15235));
                    break;
                }
                _15285 = float3(fast::max(0.0, _15235));
                break;
            }
        } while(false);
        _15419 = _14617 + (((buffer.u_AreaLightsColor[0].xyz * _7184) * (((_3808 * _8997.x) + ((float3(1.0) - _3808) * _8997.y)) * _15285)) * 1.0);
        _15378 = _14616 + ((((_3779 * buffer.u_AreaLightsColor[0].xyz) * _7184) * _14971) * 1.0);
    }
    else
    {
        _15419 = _14617;
        _15378 = _14616;
    }
    float _10633 = (buffer.u_AreaLightsIntensity[1] * buffer.u_AreaLightsEnabled[1]) * 3.1415920257568359375;
    float3 _15945;
    float3 _15946;
    if (buffer.u_AreaLightsEnabled[1] > 0.5)
    {
        float _10786 = 1.0 - fast::max(0.0, _13068);
        float _10800 = _10786 * _10786;
        float _10818 = fma(fma(_13068, _3839, -_13068), _13068, 1.0);
        _15946 = _15419 + (((((_3808 + ((float3(1.0) - _3808) * ((_10800 * _10800) * _10786))) * (((_3839 * 0.31830990314483642578125) / fma(_10818, _10818, 1.0000000116860974230803549289703e-07)) * 0.25)) * _13068) * buffer.u_AreaLightsColor[1].xyz) * _10633);
        _15945 = _15378 + (((_3779 * buffer.u_AreaLightsColor[1].xyz) * _10633) * (_13068 * 0.31830990314483642578125));
    }
    else
    {
        _15946 = _15419;
        _15945 = _15378;
    }
    out.o_fragColor = float4(pow(fast::max((_15945 + (float4((pow(fast::max(u_FresnelTex.sample(u_FresnelTexSmplr, in.v_uv0).xyz, float3(9.9999997473787516355514526367188e-06)), float3(2.2000000476837158203125)) * buffer.u_FresnelCol.xyz) * buffer.u_FresnelIntensity, buffer.u_FresnelPow).xyz * pow(fast::max(1.0 - _3790, 9.9999997473787516355514526367188e-06), fast::max(buffer.u_FresnelPow, 9.9999997473787516355514526367188e-06)))) + _15946, float3(9.9999997473787516355514526367188e-06)), float3(0.4545454680919647216796875)), buffer._AlbedoColor.w);
    return out;
}

